<?php
require('fpdf.php');


class PDF_MySQL_Table extends FPDF
{
var $ProcessingTable=false;
var $aCols=array();
var $TableX;
var $HeaderColor;
var $RowColors;
var $ColorIndex;

function Header()
{
	//Print the table header if necessary
	if($this->ProcessingTable)
		$this->TableHeader();
}

function TableHeader()
{
$this->Cell(-9);
	$this->SetFont('Arial','B',9);
	//$this->SetX($this->TableX);
	$fill=!empty($this->HeaderColor);
	if($fill)
		$this->SetFillColor($this->HeaderColor[0],$this->HeaderColor[1],$this->HeaderColor[2]);
	foreach($this->aCols as $col)
		$this->cell($col['w'],6,$col['c'],1,0,'C',$fill);
	$this->Ln();
	
}

function Rowboldtest($data)
{

    //Calculate the height of the row
    $nb=0;
    for($i=0;$i<count($data);$i++){
	if($i==0){
	$w = 183;
	}
	if($i==1){
	$w = 25;
	}
	
    $nb=max($nb,$this->NbLines($w,$data[$i]));
			}
    $h=5*2.5;

    //Issue a page break first if needed
    $this->CheckPageBreak($h);
    //Draw the cells of the row
    for($i=0;$i<count($data);$i++)
    {

    $a=isset($this->aligns[$i]) ? $this->aligns[$i] : 'L';
	if($i==0){
	$w = 133;
	
	}
	if($i==1){
	$w = 50;
	$a ="R";
	}
	if($i==2){
	$w = 25;
	$a ="R";
	}

	
  //$w=$this->widths[$i];
      
        //Save the current position
        $x=$this->GetX();
        $y=$this->GetY();
        //Draw the border
        $this->Rect($x,$y,$w,$h);
        //Print the text
		$this->SetFont('Arial','B',11);
        $this->MultiCell($w,5,$data[$i],0,$a);
        //Put the position to the right of the cell
        $this->SetXY($x+$w,$y);
    }
    //Go to the next line
    $this->Ln($h);
}
function Rowall($data,$heih)
{

    //Calculate the height of the row
    $nb=0;
    for($i=0;$i<count($data);$i++){
	if($i==0){
	$w = 240;
	}

	
    $nb=max($nb,$this->NbLines($w,$data[$i]));
			}
    $h=5*1.5;

    //Issue a page break first if needed
    $this->CheckPageBreak($h);
    //Draw the cells of the row
    for($i=0;$i<count($data);$i++)
    {

    $a=isset($this->aligns[$i]) ? $this->aligns[$i] : 'L';
	if($i==0){
	$w = 208;
	$a ="R";
	}
	

	$heih = $heih+0;
  //$w=$this->widths[$i];
      
        //Save the current position
        $x=$this->GetX();
        $y=$this->GetY();
        //Draw the border
         $this->Rect($x,$y,$w,$heih);
        //Print the text
		$this->SetFont('Arial','B',9);
        $this->MultiCell($w,$heih,"",0,$a);
        //Put the position to the right of the cell
        $this->SetXY($x+$w,$y+($heih-7));
    }
    //Go to the next line
    $this->Ln($h);
}

function Row($data)
{

    //Calculate the height of the row
    $nb=0;
    for($i=0;$i<count($data);$i++){
	if($i==0){
	$w = 10;
	}
	if($i==1){
	$w = 25;
	}
	if($i==2){
	$w = 40;
	}
	if($i==3){
	$w = 10;
	}
	if($i==4){
	$w = 20;
	}
	if($i==5){
	$w = 20;
	}
	if($i==6){
	$w = 25;
	}
	if($i==7){
	$w = 20;
	}
	if($i==8){
	$w = 25;
	}
	
    $nb=max($nb,$this->NbLines($w,$data[$i]));
			}
    $h=5*4;

    //Issue a page break first if needed
    $this->CheckPageBreak($h);
    //Draw the cells of the row
    for($i=0;$i<count($data);$i++)
    {

    $a=isset($this->aligns[$i]) ? $this->aligns[$i] : 'L';
	if($i==0){
	$w = 6;
	}
	if($i==1){
	$w = 20;
	}
	if($i==2){
	$w = 39;
	}
	if($i==3){
	$w = 13;
	}
	if($i==4){
	$w = 10;
	
	}
	if($i==5){
	$w = 10;
		$a ="R";
	}
	if($i==6){
	$w = 15;
		$a ="R";
	}
	if($i==7){
	$w = 17;
		$a ="R";
	}
	if($i==8){
	$w = 12;
	$a ="R";
	}
	if($i==9){
	$w = 23;
	$a ="R";
	}
	if($i==10){
	$w = 20;
	$a ="R";
	}
	if($i==11){
	$w = 23;
	$a ="R";
	}
  //$w=$this->widths[$i];
      
        //Save the current position
        $x=$this->GetX();
        $y=$this->GetY();
        //Draw the border
        $this->Rect($x,$y,$w,$h);
        //Print the text
		$this->SetFont('Arial','',7);
        $this->MultiCell($w,5,$data[$i],0,$a);
        //Put the position to the right of the cell
        $this->SetXY($x+$w,$y);
    }
    //Go to the next line
    $this->Ln($h);
}
function Rowbold($data)
{

    //Calculate the height of the row
    $nb=0;
    for($i=0;$i<count($data);$i++){
	if($i==0){
	$w = 10;
	}
	if($i==1){
	$w = 25;
	}
	if($i==2){
	$w = 40;
	}
	if($i==3){
	$w = 10;
	}
	if($i==4){
	$w = 20;
	}
	if($i==5){
	$w = 20;
	}
	if($i==6){
	$w = 25;
	}
	if($i==7){
	$w = 20;
	}
	if($i==8){
	$w = 25;
	}
	
    $nb=max($nb,$this->NbLines($w,$data[$i]));
			}
    $h=5*2;

    //Issue a page break first if needed
    $this->CheckPageBreak($h);
    //Draw the cells of the row
    for($i=0;$i<count($data);$i++)
    {

    $a=isset($this->aligns[$i]) ? $this->aligns[$i] : 'L';
	if($i==0){
	$w = 6;
	}
	if($i==1){
	$w = 20;
	}
	if($i==2){
	$w = 39;
	}
	if($i==3){
	$w = 13;
	}
	if($i==4){
	$w = 10;
	
	}
	if($i==5){
	$w = 10;
		$a ="R";
	}
	if($i==6){
	$w = 15;
		$a ="R";
	}
	if($i==7){
	$w = 17;
		$a ="R";
	}
	if($i==8){
	$w = 12;
	$a ="R";
	}
	if($i==9){
	$w = 23;
	$a ="R";
	}
	if($i==10){
	$w = 20;
	$a ="R";
	}
	if($i==11){
	$w = 23;
	$a ="R";
	}
  //$w=$this->widths[$i];
      
        //Save the current position
        $x=$this->GetX();
        $y=$this->GetY();
        //Draw the border
        $this->Rect($x,$y,$w,$h);
        //Print the text
		$this->SetFont('Arial','B',9);
        $this->MultiCell($w,5,$data[$i],0,$a);
        //Put the position to the right of the cell
        $this->SetXY($x+$w,$y);
		
		
    }
    //Go to the next line
    $this->Ln($h);
}
function Rowold($data)
{
$current_y = $this->GetY();
$current_x = $this->GetX();
$this->SetFont('Arial','',9);
	$this->SetX($this->TableX);
	$ci=$this->ColorIndex;
	$fill=!empty($this->RowColors[$ci]);
	if($fill)
		$this->SetFillColor($this->RowColors[$ci][0],$this->RowColors[$ci][1],$this->RowColors[$ci][2]);
	foreach($this->aCols as $col){
		//$data[$col['f']] = wordwrap($data[$col['f']],15,"\n");
		//$this->Cell($col['w'],5,$data[$col['f']],1,0,"L",$fill);
		
		$x=$this->GetX();
		$y=$this->GetY();
		//Draw the border
		$this->Rect($x,$y,$col['w'],5);
		//Print the text
		$this->MultiCell($col['w'],5,$data[$col['f']],0,"L");
		//Put the position to the right of the cell
		$this->SetXY($x+$col['w'],$y);
		}
	$this->Ln();
	$this->ColorIndex=1-$ci;
}
function CheckPageBreak($h)
{

    //If the height h would cause an overflow, add a new page immediately
    if($this->GetY()+$h>$this->PageBreakTrigger){

        $this->AddPage($this->CurOrientation);
			$this->Cell(-9);
		}
		
}
function NbLines($w,$txt)
{
    //Computes the number of lines a MultiCell of width w will take
    $cw=&$this->CurrentFont['cw'];
    if($w==0)
        $w=$this->w-$this->rMargin-$this->x;
    $wmax=($w-2*$this->cMargin)*1000/$this->FontSize;
    $s=str_replace("\r",'',$txt);
    $nb=strlen($s);
    if($nb>0 and $s[$nb-1]=="\n")
        $nb--;
    $sep=-1;
    $i=0;
    $j=0;
    $l=0;
    $nl=1;
    while($i<$nb)
    {
        $c=$s[$i];
        if($c=="\n")
        {
            $i++;
            $sep=-1;
            $j=$i;
            $l=0;
            $nl++;
            continue;
        }
        if($c==' ')
            $sep=$i;
        $l+=$cw[$c];
        if($l>$wmax)
        {
            if($sep==-1)
            {
                if($i==$j)
                    $i++;
            }
            else
                $i=$sep+1;
            $sep=-1;
            $j=$i;
            $l=0;
            $nl++;
        }
        else
            $i++;
    }
    return $nl;
}

function CalcWidths($width,$align)
{
	//Compute the widths of the columns
	$TableWidth=0;
	foreach($this->aCols as $i=>$col)
	{
		$w=$col['w'];
		if($w==-1)
			$w=$width/count($this->aCols);
		elseif(substr($w,-1)=='%')
			$w=$w/100*$width;
		$this->aCols[$i]['w']=$w;
		$TableWidth+=$w;
	}
	//Compute the abscissa of the table
	if($align=='C')
		$this->TableX=max(($this->w-$TableWidth)/2,0);
	elseif($align=='R')
		$this->TableX=max($this->w-$this->rMargin-$TableWidth,0);
	else
		$this->TableX=$this->lMargin;
}

function AddCol($field=-1,$width=-1,$caption='',$align='L')
{
	//Add a column to the table
	if($field==-1)
		$field=count($this->aCols);
	$this->aCols[]=array('f'=>$field,'c'=>$caption,'w'=>$width,'a'=>$align);
}

function Table($query,$prop=array(),$docid)
{
	//Issue query
	$res=mysql_query($query) or die('Error: '.mysql_error()."<BR>Query: $query");
	//Add all columns if none was specified
	if(count($this->aCols)==0)
	{
		$nb=mysql_num_fields($res);
		for($i=0;$i<$nb;$i++)
			$this->AddCol();
	}
	//Retrieve column names when not specified
	foreach($this->aCols as $i=>$col)
	{
		if($col['c']=='')
		{
			if(is_string($col['f']))
				$this->aCols[$i]['c']=ucfirst($col['f']);
			else
				$this->aCols[$i]['c']=ucfirst(mysql_field_name($res,$col['f']));
		}
	}
	//Handle properties
	if(!isset($prop['width']))
		$prop['width']=0;
	if($prop['width']==0)
		$prop['width']=$this->w-$this->lMargin-$this->rMargin;
	if(!isset($prop['align']))
		$prop['align']='C';
	if(!isset($prop['padding']))
		$prop['padding']=$this->cMargin;
	$cMargin=$this->cMargin;
	$this->cMargin=$prop['padding'];
	if(!isset($prop['HeaderColor']))
		$prop['HeaderColor']=array();
	$this->HeaderColor=$prop['HeaderColor'];
	if(!isset($prop['color1']))
		$prop['color1']=array();
	if(!isset($prop['color2']))
		$prop['color2']=array();
	$this->RowColors=array($prop['color1'],$prop['color2']);
	//Compute column widths
	$this->CalcWidths($prop['width'],$prop['align']);
	//Print header
	$this->TableHeader();
	//Print rows
	$this->SetFont('Arial','',11);
	$this->ColorIndex=0;
	$this->ProcessingTable=true;
	$a=1;
	$dataprint = array();
	//$this->SetX($this->TableX);

	while($row=mysql_fetch_array($res)){
		
		$dataprint[0] = $a;
		$dataprint[1] = $row[code];
		$row[name] = str_replace("<br>"," ",$row[name]);
		$dataprint[2] = substr($row[name],0,85);
		$dataprint[3] = $row[warehouse];
	$dataprint[4] = $row[uom];
		
				
		$subamount = ($row['price']*$row['qty']);
					$dataprint[5] =  number_format($row[qty],2,'.',',');
		$dataprint[6] =  number_format($row[price],2,'.',',');

		$dataprint[7] = number_format($subamount,2,'.',',');
		$dataprint[8] =  number_format($row[discount],2,'.',',');
		$subamount = ($row['price']*$row['qty'])-$row['discount'];
		$taxamount = ($subamount*$row['taxpercent'])/100;
		$dataprint[9] = number_format($subamount,2,'.',',');
		
		$dataprint[10] = number_format($taxamount,2,'.',',');
			$dataprint[11] = number_format($subamount+$taxamount,2,'.',',');
$this->Cell(-9);
		$this->Row($dataprint);

		$a+=1;
		$toexl += number_format($subamount,2,'.','');
		$togst += number_format($taxamount,2,'.','');
		
	}
	if($a<6){
	$theight = (6-$a)*20;
	$dataprint3[0] = "";
	$this->Cell(-9);
	$this->Rowall($dataprint3,$theight);
	}
	$this->Cell(-9);
		$dataprint[0] = "";
		$dataprint[1] = "";
		$dataprint[2] ="";
	$dataprint[3] ="";
		$dataprint[4] ="";
	
		$dataprint[5] ="";
		
			$dataprint[6] ="";
				$dataprint[7] ="";
					$dataprint[8] ="";
		$dataprint[9] = "".number_format($toexl,2,'.',',');
		$dataprint[10] = "".number_format($togst,2,'.',',');
		$dataprint[11] = "".number_format($toexl+$togst,2,'.',',');

		$this->Rowbold($dataprint);
	//$sql1= "SELECT * FROM debtor_invoice where id='$docid'";
$result = mysql_query($sql1);
$cv2= mysql_fetch_array($result);
	$this->Cell(-9);
	$num = number_format($toexl+$togst,2,'.','');
	$nw = new Numbers_Words();
	$dataprint2[0] = $cv2[currency].":".strtoupper($nw->toCurrency($num));;
	$dataprint2[1] = "Total Payable Incl GST:";
		$dataprint2[2] = number_format($toexl+$togst,2,'.',',');
	$this->Rowboldtest($dataprint2);
	
	//$row2=mysql_fetch_array(mysql_query('select code,name,terms from creditor order by code'));
	//$row2 = array("code"=>"35","name"=>"37","terms"=>"43");
	//$this->Row($row2);
$this->ProcessingTable=false;
	$this->cMargin=$cMargin;
	$this->aCols=array();
}
}
?>
