<?php
require('fpdf.php');

class PDF_MySQL_Table extends FPDF
{
var $ProcessingTable=false;
var $aCols=array();
var $TableX;
var $HeaderColor;
var $RowColors;
var $ColorIndex;

function Header()
{
	//Print the table header if necessary
	if($this->ProcessingTable)
		$this->TableHeader();
}

function TableHeader()
{
    $this->SetX(7);
	$this->SetFont('Arial','B',9);
	//$this->SetX($this->TableX);
	$fill=!empty($this->HeaderColor);
	if($fill)
		$this->SetFillColor($this->HeaderColor[0],$this->HeaderColor[1],$this->HeaderColor[2]);
	foreach($this->aCols as $col)
		$this->Cell($col['w'],6,$col['c'],1,0,$col['a'],$fill);
	$this->Ln();
}

function Row($data)
{

    //Calculate the height of the row
    $nb=0;
    for($i=0;$i<count($data);$i++){
	if($i==0){
	$w = 8;
	}
	if($i==1){
	$w = 15;
	}
	if($i==2){
	$w = 70;
	}
	if($i==3){
	$w = 15;
	}
	if($i==4){
	$w = 15;
	}
	if($i==5){
	$w = 20;
	}
	if($i==6){
	$w = 20;
	}
	if($i==7){
	$w = 20;
	}
	
    $nb=max($nb,$this->NbLines($w,$data[$i]));
			}
			
		
    $h=5;

    //Issue a page break first if needed
    $this->CheckPageBreak(40);
    //Draw the cells of the row
    for($i=0;$i<count($data);$i++)
    {

    $a=isset($this->aligns[$i]) ? $this->aligns[$i] : 'L';
	if($i==0){
	$w = 7;
	$a ="L";
	}
	if($i==1){
	$w = 30;
	$a ="L";
	}
	if($i==2){
	$w = 40;
	$a ="L";
	}
	if($i==3){
    $w = 15;
    $a ="L";
	}
	if($i==4){
	$w = 15;
	$a ="L";
	}
	if($i==5){
	$w =13;
	$a ="L";
	}
	if($i==6){
	$w =21;
	$a ="L";
	}
	if($i==7){
	$w =36;
	$a ="L";
	}
	if($i==8){
	$w = 8;
	$a ="R";
	}
	if($i==9){
	$w = 15;
	$a ="L";
	}
	
	
	if($i==1){
	    $lenthofdesciption = strlen($data[1]);// $k is number of row of data from sql
    
        if($lenthofdesciption>18){  //If character length > 35, then go next row 
            $h+=5;
        }
	}
	if($i==2){
	    $lenthofdesciption = strlen($data[2]);// $k is number of row of data from sql
    
        if($lenthofdesciption>19){  //If character length > 35, then go next row 
            $h+=5;
        }
	}
	if($i==3){
	    $lenthofdesciption = strlen($data[3]);// $k is number of row of data from sql
    
        if($lenthofdesciption>7){  //If character length > 35, then go next row 
            $h+=5;
        }
	}
	if($i==6){
	    $lenthofdesciption = strlen($data[6]);// $k is number of row of data from sql
    
        if($lenthofdesciption>11){  //If character length > 35, then go next row 
            $h+=5;
        }
	}
	if($i==7){
	    $lenthofdesciption = strlen($data[7]);// $k is number of row of data from sql
    
        if($lenthofdesciption>20){  //If character length > 35, then go next row 
            $h+=5;
        }
	}
		/*if($i==2){
			$n = explode("\n",$data[$i]);
			//$data[$i] = $n[0];
		    $h = sizeof($n)*6;
		}*/
			
	
  //$w=$this->widths[$i];
      
        //Save the current position
        $x=$this->GetX();
        $y=$this->GetY();
        if($i==0){
            $this->SetX(7);
        }else{
            $this->SetX($x-3);
        }
        //Draw the border
       // $this->Rect($x,$y,$w,$h);
        //Print the text
		$this->SetFont('Arial','',8);
		if($i==6){
        $this->MultiCell($w,5,$data[$i],0,$a);
		}else{
		  $this->MultiCell($w,5,$data[$i],0,$a);
		}
        //Put the position to the right of the cell
        $this->SetXY($x+$w,$y);
    }
    //Go to the next line
    $this->Ln($h);
}

function Rowboldtestnew($data)
{

    //Calculate the height of the row
    $nb=0;
    for($i=0;$i<count($data);$i++){
	if($i==0){
	$w = 80;
	}
	if($i==1){
	$w = 20;
	}
	
    $nb=max($nb,$this->NbLines($w,$data[$i]));
			}
    $h=5*1;

    //Issue a page break first if needed
    $this->CheckPageBreak($h);
    //Draw the cells of the row
    for($i=0;$i<count($data);$i++)
    {

    $a=isset($this->aligns[$i]) ? $this->aligns[$i] : 'L';
	if($i==0){
	$w = 13;
	$a ="L";
	}
	if($i==1){
	$w = 100;
	$a ="R";
	}
	if($i==2){
	$w = 15;
	$a ="L";
	}
	if($i==3){
	$w = 38;
	$a ="C";
	}
	if($i==4){
	$w = 27;
	$a ="L";
	}

	
  //$w=$this->widths[$i];
      
        //Save the current position
        $x=$this->GetX();
        $y=$this->GetY();
        //Draw the border

		if($i==2){
        //$this->Rect($x,$y,$w,$h);
		 //$this->Line(145, 195, 120, 195);
		  //$this->Line(145, 196, 120, 196);
		}
        //Print the text
			if($i==0){
		$this->SetFont('Arial','',8);
		}else{
				$this->SetFont('Arial','',10);
		}
        $this->MultiCell($w,5,$data[$i],0,$a);
        //Put the position to the right of the cell
        $this->SetXY($x+$w,$y);
    }
    //Go to the next line
    $this->Ln($h);
}


function Rowboldtest($data)
{

    //Calculate the height of the row
    $nb=0;
    for($i=0;$i<count($data);$i++){
	if($i==0){
	$w = 177;
	}
	if($i==1){
	$w = 20;
	}
	
    $nb=max($nb,$this->NbLines($w,$data[$i]));
			}
    $h=5*1;

    //Issue a page break first if needed
    $this->CheckPageBreak($h);
    //Draw the cells of the row
    for($i=0;$i<count($data);$i++)
    {

    $a=isset($this->aligns[$i]) ? $this->aligns[$i] : 'L';
	if($i==0){
	$w = 210;
	$a ="L";
	}
	if($i==1){
	$w = 25;
	$a ="R";
	}

	
  //$w=$this->widths[$i];
      
        //Save the current position
        $x=$this->GetX();
        $y=$this->GetY();
        //Draw the border
		if($i==1){
        $this->Rect($x,$y,$w,$h);
		}
        //Print the text
		$this->SetFont('Arial','',9);
        $this->MultiCell($w,5,$data[$i],0,$a);
        //Put the position to the right of the cell
        $this->SetXY($x+$w,$y);
    }
    //Go to the next line
    $this->Ln($h);
}
function Rowall($data)
{

    //Calculate the height of the row
    $nb=0;
    for($i=0;$i<count($data);$i++){
	if($i==0){
	$w = 10;
	}
	if($i==1){
	$w = 25;
	}
	if($i==2){
	$w = 52;
	}
	if($i==3){
	$w = 15;
	}
	if($i==4){
	$w = 15;
	}
	if($i==5){
	$w = 20;
	}
	if($i==6){
	$w = 20;
	}
	if($i==7){
	$w = 20;
	}
	if($i==8){
	$w = 20;
	}
	
    $nb=max($nb,$this->NbLines($w,$data[$i]));
			}
    $h=5*2;

    //Issue a page break first if needed
    $this->CheckPageBreak($h);
    //Draw the cells of the row
    for($i=0;$i<count($data);$i++)
    {

    $a=isset($this->aligns[$i]) ? $this->aligns[$i] : 'L';
	if($i==0){
	$w = 10;
	}
	if($i==1){
	$w = 20;
		$a ="C";
	}
	if($i==2){
	$w = 37;
	}

	if($i==3){
	$w = 60;
	}
	if($i==4){
	$w = 20;
	$a ="C";
	}
	if($i==5){
	$w = 25;
	$a ="R";
	}
	if($i==6){
	$w = 25;
		$a ="R";
	}
	
	
	
  //$w=$this->widths[$i];
      
        //Save the current position
        $x=$this->GetX();
        $y=$this->GetY();
        //Draw the border
       // $this->Rect($x,$y,$w,$h);
        //Print the text
		$this->SetFont('Arial','',9);
		if($i==6){
        $this->MultiCell($w,$h,$data[$i],R,$a);
		}else{
		  $this->MultiCell($w,$h,$data[$i],LR,$a);
		}
        //Put the position to the right of the cell
        $this->SetXY($x+$w,$y);
    }
    //Go to the next line
    $this->Ln($h);
}
function Rowall2($data)
{

    //Calculate the height of the row
    $nb=0;
    for($i=0;$i<count($data);$i++){
	if($i==0){
	$w = 10;
	}
	if($i==1){
	$w = 25;
	}
	if($i==2){
	$w = 52;
	}
	if($i==3){
	$w = 15;
	}
	if($i==4){
	$w = 15;
	}
	if($i==5){
	$w = 20;
	}
	if($i==6){
	$w = 20;
	}
	if($i==7){
	$w = 20;
	}
	if($i==8){
	$w = 20;
	}
	
    $nb=max($nb,$this->NbLines($w,$data[$i]));
			}
    $h=5*2;

    //Issue a page break first if needed
    $this->CheckPageBreak($h);
    //Draw the cells of the row
    for($i=0;$i<count($data);$i++)
    {

    $a=isset($this->aligns[$i]) ? $this->aligns[$i] : 'L';
	if($i==0){
	$w = 10;
	}
	if($i==1){
	$w = 20;
		$a ="C";
	}
	if($i==2){
	$w = 37;
	}

	if($i==3){
	$w = 60;
	}
	if($i==4){
	$w = 20;
	$a ="C";
	}
	if($i==5){
	$w = 25;
	$a ="R";
	}
	if($i==6){
	$w = 25;
		$a ="R";
	}
	
	
	
  //$w=$this->widths[$i];
      
        //Save the current position
        $x=$this->GetX();
        $y=$this->GetY();
        //Draw the border
       // $this->Rect($x,$y,$w,$h);
        //Print the text
		$this->SetFont('Arial','',9);
		if($i==6){
        $this->MultiCell($w,$h,$data[$i],RB,$a);
		}else{
		  $this->MultiCell($w,$h,$data[$i],LRB,$a);
		}
        //Put the position to the right of the cell
        $this->SetXY($x+$w,$y);
    }
    //Go to the next line
    $this->Ln($h);
}
function CheckPageBreak($h)
{
    //If the height h would cause an overflow, add a new page immediately
    if($this->GetY()+$h>$this->PageBreakTrigger)
        $this->AddPage($this->CurOrientation);
}
function NbLines($w,$txt)
{
    //Computes the number of lines a MultiCell of width w will take
    $cw=&$this->CurrentFont['cw'];
    if($w==0)
        $w=$this->w-$this->rMargin-$this->x;
    $wmax=($w-2*$this->cMargin)*1000/$this->FontSize;
    $s=str_replace("\r",'',$txt);
    $nb=strlen($s);
    if($nb>0 and $s[$nb-1]=="\n")
        $nb--;
    $sep=-1;
    $i=0;
    $j=0;
    $l=0;
    $nl=1;
    while($i<$nb)
    {
        $c=$s[$i];
        if($c=="\n")
        {
            $i++;
            $sep=-1;
            $j=$i;
            $l=0;
            $nl++;
            continue;
        }
        if($c==' ')
            $sep=$i;
        $l+=$cw[$c];
        if($l>$wmax)
        {
            if($sep==-1)
            {
                if($i==$j)
                    $i++;
            }
            else
                $i=$sep+1;
            $sep=-1;
            $j=$i;
            $l=0;
            $nl++;
        }
        else
            $i++;
    }
    return $nl;
}

function CalcWidths($width,$align)
{
	//Compute the widths of the columns
	$TableWidth=0;
	foreach($this->aCols as $i=>$col)
	{
		$w=$col['w'];
		if($w==-1)
			$w=$width/count($this->aCols);
		elseif(substr($w,-1)=='%')
			$w=$w/100*$width;
		$this->aCols[$i]['w']=$w;
		$TableWidth+=$w;
	}
	//Compute the abscissa of the table
	if($align=='C')
		$this->TableX=max(($this->w-$TableWidth)/2,0);
	elseif($align=='R')
		$this->TableX=max($this->w-$this->rMargin-$TableWidth,0);
	else
		$this->TableX=$this->lMargin;
}

function AddCol($field=-1,$width=-1,$caption='',$align)
{
	//Add a column to the table
	if($field==-1)
		$field=count($this->aCols);
	$this->aCols[]=array('f'=>$field,'c'=>$caption,'w'=>$width,'a'=>$align);
}

function Table($query,$prop=array(),$id)
{
	//Issue query
	$res=mysql_query($query) or die('Error: '.mysql_error()."<BR>Query: $query");
	//Add all columns if none was specified
	if(count($this->aCols)==0)
	{
		$nb=mysql_num_fields($res);
		for($i=0;$i<$nb;$i++)
			$this->AddCol();
	}
	//Retrieve column names when not specified
	foreach($this->aCols as $i=>$col)
	{
		if($col['c']=='')
		{
			if(is_string($col['f']))
				$this->aCols[$i]['c']=ucfirst($col['f']);
			else
				$this->aCols[$i]['c']=ucfirst(mysql_field_name($res,$col['f']));
		}
	}
	//Handle properties
	if(!isset($prop['width']))
		$prop['width']=0;
	if($prop['width']==0)
		$prop['width']=$this->w-$this->lMargin-$this->rMargin;
	if(!isset($prop['align']))
		$prop['align']='C';
	if(!isset($prop['padding']))
		$prop['padding']=$this->cMargin;
	$cMargin=$this->cMargin;
	$this->cMargin=$prop['padding'];
	if(!isset($prop['HeaderColor']))
		$prop['HeaderColor']=array();
	$this->HeaderColor=$prop['HeaderColor'];
	if(!isset($prop['color1']))
		$prop['color1']=array();
	if(!isset($prop['color2']))
		$prop['color2']=array();
	$this->RowColors=array($prop['color1'],$prop['color2']);
	//Compute column widths
	$this->CalcWidths($prop['width'],$prop['align']);
	//Print header
	$this->TableHeader();
	//Print rows
	$this->SetFont('Arial','',11);
	$this->ColorIndex=0;
	$this->ProcessingTable=true;
	$a=1;
	$dataprint = array();
	$dataprint2 = array();
	//$this->SetX($this->TableX);
	    $r =1;
	while($row=mysql_fetch_array($res)){
$sql1= "SELECT * FROM  grade where grade_no='$row[grade]'";
$staff= mysql_fetch_array(mysql_query($sql1));

$subamount = ($row['price']*$row['qty'])-$row['discount'];
$taxamount = ($subamount*$row['taxpercent'])/100;
$tsubamount += $subamount;
$ttaxamount += $taxamount;
$twsubamount += $subamount;
$tqty += $row[itemno];
$tqty2 += $row[qty_in];

		$dataprint[0] = $r;
		$dataprint[1] = $row[grade];
		$dataprint[2] = $row[batch];
		$dataprint[3] = $row[storageid];
		$dataprint[4] = $row[itemno];
		$dataprint[5] = $row[saf_cust_plt_no];
		$dataprint[6] = $row[palletno];
		$dataprint[7] = $row[customno];
		$dataprint[8] = $row[qty_in];
		$dataprint[9] = $row[unit];
		

		//$dataprint[6] =  number_format($row[discount],2,'.',',');
	
		$subamount = ($row['price']*$row['qty'])-$row['discount'];
		$taxamount = ($subamount*$row['taxpercent'])/100;
		$gst = 0.06;
			

		$this->Row($dataprint);
		$a+=1;
		$toexl += number_format($subamount,2,'.','');
		$togst += number_format($taxamount,2,'.','');
		$totalgst = $toexl*$gst;
		
		$r+=1;
	}
			$num = number_format($toexl+$totalgst,2,'.','');
$nw = new Numbers_Words();
	$cduit ="RINGGIT MALAYSIA : ".strtoupper($nw->toCurrency($num));
	$this->Line(10, 241, 200, 241);
	$this->Line(10, 241, 200, 241);
	$this->Line(10, 241, 200, 241);
	
	$this->SetXY($x+10,241);
	//$dataprint2[0] = 	$cduit;
	//$this->Rowboldtest($dataprint2);
	
	//$this->SetXY($x+10,250);
		$sql1= "SELECT * FROM inv where id='$id'";
$result = mysql_query($sql1);
$cv= mysql_fetch_array($result);
		//$dataprint2[0] = 	$cduit;
		$dataprint2[0] = " ";
		$dataprint2[1] = "Total Quantity :";
		$dataprint2[2] = $tqty;
		$dataprint2[3] = "";
		$dataprint2[4] = $tqty2;
	$this->Rowboldtestnew($dataprint2);
	

	
	//$row2=mysql_fetch_array(mysql_query('select code,name,terms from creditor order by code'));
	//$row2 = array("code"=>"35","name"=>"37","terms"=>"43");
	//$this->Row($row2);
$this->ProcessingTable=false;
	$this->cMargin=$cMargin;
	$this->aCols=array();
}
}
?>
